'****************************************************
'* Inductance-capacitance electrolytic capacitor measuring instrument *
'* Capacitance: 1P-2.5uF *
'* Inductance: 1uH-2.0H *
'* Electrolytic Capacitors: 0.1uF-20000uF *
'* www.avrprojects.info *
'****************************************************
$regfile = "m8def.dat"
$crystal = 4000000

   Config Portc = Input
   Config Portb = Output
   Ddrd.7 = 0
   Portd.7 = 1

   Config Adc = Single , Prescaler = Auto , Reference = Avcc

Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portb.1 , Rs = Portb.0
Config Lcd = 16 * 2
Dim Vin As Word
Dim Vout As Single
Dim Togva As Byte
Togva = 0

Cls
Cursor Off
Do
If Pind.7 = 0 Then
Waitms 50                                                   'Voltmeter'
If Pind.7 = 0 Then
Togva = Togva + 1
Bitwait Portd.7 , Set
End If
End If
If Togva = 2 Then Togva = 0


If Togva = 0 Then
Start Adc
Vin = Getadc(1)
Vout = Vin * 4.88
Vout = Vout / 100
Locate 1 , 1
Lcd "v=" ; Vout
Waitms 50
Stop Adc
End If
'--------------------------------------------------------------------------

If Togva = 1 Then
Start Adc                                                   'Ampermeter'
Vin = Getadc(0)
Vout = Vin * 4.88
Vout = Vout / 5
Locate 1 , 1
Lcd "MA=" ; Vout
Waitms 50
Stop Adc
End If

Loop